config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  # Almost every application defines a route for the root path ("/") at the top of this file.
  root 'home#index'
  post '/search', to: 'home#search'
  get '/clear_message', to: 'home#clear_message'

  resources :posts do
    resources :likes, only: %i[create destroy]
    resources :comments, only: %i[new create destroy]
  end

  get '/login', to: 'session#index', as: 'new_session'
  post '/login', to: 'session#create'
  delete '/logout', to: 'session#destroy', as: 'destroy_session'

  get '/register', to: 'registration#index', as: 'new_registration'
  post '/register', to: 'registration#create'
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
  belongs_to :user

  has_rich_text :message

  validates_presence_of :message
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :set_post

  def new
    @comment = @post.comments.build
  end

  def create
    @comment = @post.comments.build(comment_params)

    respond_to do |format|
      if @comment.save
        format.turbo_stream
        format.html { redirect_to @post, notice: 'Comment was successfully created.' }
      else
        format.turbo_stream
        format.html { render :new }
      end
    end
  end

  def destroy
    @comment = @post.comments.find(params[:id])

    respond_to do |format|
      if @comment.destroy
        format.turbo_stream
        format.html { redirect_to @post, notice: 'Comment was successfully destroyed.' }
      else
        format.turbo_stream
        format.html { render :new }
      end
    end
  end

  private

  def set_post
    @post = Post.find(params[:post_id])
  end

  def comment_params
    params.require(:comment).permit(:message, :post_id, :user_id)
  end
end

app/helpers/comments_helper.rb
# frozen_string_literal: true

# module CommentsHelper
module CommentsHelper
  STATUS = {
    success: 'px-4 py-3 leading-normal text-blue-700 border border-blue-500 rounded-lg',
    error: 'px-4 py-3 leading-normal text-red-700 border border-red-500 rounded-lg',
    info: 'px-4 py-3 leading-normal text-gren-700 border border-green-500 rounded-lg'
  }.freeze

  def notice_comment_stream(message:, status:)
    turbo_stream.append :notice_comment, partial: 'shared/notice', locals: { notice: message, status: STATUS[status] }
  end
end

app/views/comments/_comment.html.erb
<%= turbo_frame_tag dom_id(comment) do %>
  <div class="w-full border-b shadow-md p-2 rounded-md p-4">
    <p><%= comment.user.name %></p>
    <%= comment.message %>

    <div class="w-full flex flex-wrap">
      <p class="ml-10 text-gray-500 font-normal order-2 self-center">Criado em: <%= comment.created_at.strftime('%d/%m/%Y') %></p>

      <% if user_signed_in? && current_user.id == comment.user_id %>
      <%= button_to 'Excluir comentário', 
        post_comment_path(comment.post, comment),
        method: :delete,
        class: 'text-gray-500 p-1 order-1 self-center bg-gray-100 rounded-md hover:bg-gray-200',
        data: { controller: 'confirm', confirm_message_value: t('messages.delete'), action: 'click->confirm#destroy'}
      %>
    <% end %>
    </div>
  </div>
<% end %>

app/views/comments/_form.html.erb
<%= form_with(
  model: [comment.post, comment],
  html: {
    data: { 
      controller: 'form', 
      action: 'submit->form#clear',
    },
    id: 'comment-form',
    class: 'w-full border-b shadow-lg px-10'
  }) do |form| %>
  <% if comment.errors.any? %>
    <div class="w-full p-2 border border-red-500 rounded-md mt-5">
      <h2 class="font-bold"><%= t('errors.template.header.other', model: comment.model_name.human ,count: comment.errors.count) %></h2>

      <ul>
        <% comment.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <%= form.hidden_field :post_id %>
  <%= form.hidden_field :user_id, value: current_user.id %>

  <div class="my-5">
    <%= form.label :message, class: 'form-label' %>
    <%= form.rich_text_area :message, class: 'form-control' %>
  </div>

  <div class="my-5 flex items-center justify-between">
    <%= form.submit 'Salvar', class: 'btn-primary' %>
    <%= link_to "Voltar", post_path(comment.post), class: 'btn-primary bg-red-500 hover:bg-red-7000' %>
  </div>
<% end %>

app/views/comments/create.turbo_stream.erb
<% unless @comment.errors.present? %>
  <%= turbo_stream.replace 'notice_comment' do %>
    <%= turbo_frame_tag :notice_comment %>
  <% end %>

  <%= notice_comment_stream(message: t('comment.messages.create'), status: :success) %>

  <%= turbo_stream.replace :new_comment do %>
    <%= turbo_frame_tag :new_comment %>
  <% end %>

  <%= turbo_stream.replace :total_comments do %>
    <%= turbo_frame_tag :total_comments do %>
      <h1 class="text-4xl text-gray-600 p-2 mt-5"><%= @comment.post.comments.size %> Comentários </h1>
    <% end %>
  <% end %>

  <%= turbo_stream.append 'comments', partial: 'comment', locals: { comment: @comment } %>

<% else %>
<%= turbo_stream.replace 'comment-form', partial: 'form', locals: { comment: @comment } %>
<% end %>

app/views/comments/destroy.turbo_stream.erb
<%= turbo_stream.replace 'notice_comment' do %>
  <%= turbo_frame_tag :notice_comment %>
<% end %>

<%= notice_comment_stream(message: t('comment.messages.destroy'), status: :error) %>


<%= turbo_stream.replace :total_comments do %>
  <%= turbo_frame_tag :total_comments do %>
    <h1 class="text-4xl text-gray-600 p-2 mt-5"><%= @comment.post.comments.size %> Comentários </h1>
  <% end %>
<% end %>

<%= turbo_stream.remove @comment %>

app/views/comments/new.html.erb
<%= turbo_frame_tag :new_comment do %>
  <div class="w-full">
    <h1 class="text-3xl text-gray-500 ml-10 mt-5" >Cadastrar comentário</h1>
    <%= javascript_tag('document.querySelector("trix-editor").focus();') %>
    <%= render 'form', comment: @comment %>
  </div>
<% end %>